/*
	XMMS Song Info plugin
	Copyright (c) 2004 Nikola Kotur

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA  02111-1307, USA.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget* create_wSongInfo (void)
{
	GtkWidget *wSongInfo;
	GtkWidget *fixed;
	GtkWidget *lmAlbum;
	GtkWidget *lmYear;
	GtkWidget *lmArtist;
	GtkWidget *lmTitle;
	GtkWidget *about_btn;

	/* The following is commented by kotnik:
	GtkWidget *lmComment;
	GtkWidget *lArtist;
	GtkWidget *lTitle;
	GtkWidget *lAlbum;
	GtkWidget *lYear;
	GtkWidget *lComment;
	*/

	wSongInfo = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (wSongInfo), "wSongInfo", wSongInfo);
	gtk_window_set_title (GTK_WINDOW (wSongInfo), _("SongInfo View"));
	gtk_window_set_policy (GTK_WINDOW (wSongInfo), FALSE, FALSE, FALSE);

	fixed = gtk_fixed_new ();
	gtk_widget_ref (fixed);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "fixed", fixed,
			    (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (fixed);
	gtk_container_add (GTK_CONTAINER (wSongInfo), fixed);
	gtk_widget_set_usize (fixed, 250, 230);

	lmAlbum = gtk_label_new (_("Album:"));
	gtk_widget_ref (lmAlbum);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lmAlbum", lmAlbum,
			    	  (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lmAlbum, 0, 80);
	gtk_widget_set_uposition (lmAlbum, 0, 80);
	gtk_misc_set_alignment(GTK_LABEL (lmAlbum), 0.0f, 0.5f);
	gtk_widget_set_usize (lmAlbum, 48, 16);
	gtk_widget_show (lmAlbum);

	lmYear = gtk_label_new (_("Year:"));
	gtk_widget_ref (lmYear);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lmYear", lmYear,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lmYear, 0, 104);
	gtk_widget_set_uposition (lmYear, 0, 104);
	gtk_widget_set_usize (lmYear, 48, 16);
	gtk_misc_set_alignment(GTK_LABEL (lmYear), 0.0f, 0.5f);
	gtk_widget_show (lmYear);

	lmArtist = gtk_label_new (_("Artist:"));
	gtk_widget_ref (lmArtist);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lmArtist", lmArtist,
				    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lmArtist, 0, 32);
	gtk_widget_set_uposition (lmArtist, 0, 32);
	gtk_widget_set_usize (lmArtist, 48, 16);
	gtk_misc_set_alignment(GTK_LABEL (lmArtist), 0.0f, 0.5f);
	gtk_widget_show (lmArtist);

	lmTitle = gtk_label_new (_("Title:"));
	gtk_widget_ref (lmTitle);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lmTitle", lmTitle,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lmTitle, 0, 56);
	gtk_widget_set_uposition (lmTitle, 0, 56);
	gtk_widget_set_usize (lmTitle, 48, 16);
	gtk_misc_set_alignment(GTK_LABEL (lmTitle), 0.0f, 0.5f);
	gtk_widget_show (lmTitle);

	lmComment = gtk_label_new (_("Comment:"));
	gtk_widget_ref (lmComment);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lmComment", lmComment,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lmComment, 0, 128);
	gtk_widget_set_uposition (lmComment, 0, 128);
	gtk_widget_set_usize (lmComment, 56, 16);
	gtk_misc_set_alignment(GTK_LABEL (lmComment), 0.0f, 0.5f);
	gtk_widget_show (lmComment);

	lArtist = gtk_label_new ("n/a");
	gtk_widget_ref (lArtist);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lArtist", lArtist,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lArtist, 48, 32);
	gtk_widget_set_uposition (lArtist, 56, 32);
	gtk_widget_set_usize (lArtist, 194, 16);
	gtk_misc_set_alignment(GTK_LABEL (lArtist), 0.0f, 0.5f);
	gtk_widget_show (lArtist);

	lTitle = gtk_label_new (_("n/a"));
	gtk_widget_ref (lTitle);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lTitle", lTitle,
				    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lTitle, 48, 56);
	gtk_widget_set_uposition (lTitle, 56, 56);
	gtk_widget_set_usize (lTitle, 194, 16);
	gtk_misc_set_alignment(GTK_LABEL (lTitle), 0.0f, 0.5f);
	gtk_widget_show (lTitle);

	lAlbum = gtk_label_new (_("n/a"));
	gtk_widget_ref (lAlbum);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lAlbum", lAlbum,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lAlbum, 48, 80);
	gtk_widget_set_uposition (lAlbum, 56, 80);
	gtk_widget_set_usize (lAlbum, 194, 16);
	gtk_misc_set_alignment(GTK_LABEL (lAlbum), 0.0f, 0.5f);
	gtk_widget_show (lAlbum);

	lYear = gtk_label_new (_("n/a"));
	gtk_widget_ref (lYear);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lYear", lYear,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lYear, 48, 104);
	gtk_widget_set_uposition (lYear, 56, 104);
	gtk_widget_set_usize (lYear, 194, 16);
	gtk_misc_set_alignment(GTK_LABEL (lYear), 0.0f, 0.5f);
	gtk_widget_show (lYear);

	lComment = gtk_label_new (_("n/a"));
	gtk_widget_ref (lComment);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "lComment", lComment,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), lComment, 56, 128);
	gtk_widget_set_uposition (lComment, 56, 128);
	gtk_widget_set_usize (lComment, 186, 16);
	gtk_misc_set_alignment(GTK_LABEL (lComment), 0.0f, 0.5f);
	gtk_widget_show (lComment);

	about_btn = gtk_button_new_with_label ("About");
	gtk_widget_ref (about_btn);
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "about_btn", about_btn,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_fixed_put (GTK_FIXED (fixed), about_btn, 200, 200);
	gtk_widget_show (about_btn);

	gtk_signal_connect (GTK_OBJECT (about_btn), "clicked",
		      GTK_SIGNAL_FUNC (do_on_about_button_clicked),
		      NULL);

	check_button = gtk_check_button_new_with_label("Show comment");
	gtk_object_set_data_full (GTK_OBJECT (wSongInfo), "check_button", check_button,
		    (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_set_uposition(check_button, 10, 200);
	gtk_fixed_put (GTK_FIXED (fixed), check_button, 0, 104);
	gtk_widget_show (check_button);

	return wSongInfo;
}


GtkWidget* create_aboutDlg (void)
{
	GtkWidget *aboutDlg;
	GtkWidget *frame8;
	GtkWidget *vbox3;
	GtkWidget *about_label;
	GtkWidget *hbuttonbox2;
	guint about_close_btn_key;
	GtkWidget *about_close_btn;
	GtkAccelGroup *accel_group;

	accel_group = gtk_accel_group_new ();

	aboutDlg = gtk_window_new (GTK_WINDOW_DIALOG);
	gtk_object_set_data (GTK_OBJECT (aboutDlg), "aboutDlg", aboutDlg);
	gtk_window_set_title (GTK_WINDOW (aboutDlg), _("About"));
	gtk_window_set_position (GTK_WINDOW (aboutDlg), GTK_WIN_POS_CENTER);

	frame8 = gtk_frame_new (_("About"));
	gtk_widget_ref (frame8);
	gtk_object_set_data_full (GTK_OBJECT (aboutDlg), "frame8", frame8,
			      (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (frame8);
	gtk_container_add (GTK_CONTAINER (aboutDlg), frame8);
	gtk_container_set_border_width (GTK_CONTAINER (frame8), 5);

	vbox3 = gtk_vbox_new (FALSE, 0);
	gtk_widget_ref (vbox3);
	gtk_object_set_data_full (GTK_OBJECT (aboutDlg), "vbox3", vbox3,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (vbox3);
	gtk_container_add (GTK_CONTAINER (frame8), vbox3);
	gtk_container_set_border_width (GTK_CONTAINER (vbox3), 10);

	about_label = gtk_label_new (_("*** about text ***"));
	gtk_widget_ref (about_label);
	gtk_object_set_data_full (GTK_OBJECT (aboutDlg), "about_label", about_label,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (about_label);
	gtk_box_pack_start (GTK_BOX (vbox3), about_label, TRUE, TRUE, 0);
	gtk_misc_set_alignment (GTK_MISC (about_label), 0.5, 0);

	hbuttonbox2 = gtk_hbutton_box_new ();
	gtk_widget_ref (hbuttonbox2);
	gtk_object_set_data_full (GTK_OBJECT (aboutDlg), "hbuttonbox2", hbuttonbox2,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (hbuttonbox2);
	gtk_box_pack_start (GTK_BOX (vbox3), hbuttonbox2, FALSE, TRUE, 0);

	about_close_btn = gtk_button_new_with_label ("");
	about_close_btn_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (about_close_btn)->child),
					 _("_Close"));
	gtk_widget_add_accelerator (about_close_btn, "clicked", accel_group,
				    about_close_btn_key, GDK_MOD1_MASK, (GtkAccelFlags) 0);
	gtk_widget_ref (about_close_btn);
	gtk_object_set_data_full (GTK_OBJECT (aboutDlg), "about_close_btn", about_close_btn,
				  (GtkDestroyNotify) gtk_widget_unref);
	gtk_widget_show (about_close_btn);
	gtk_container_add (GTK_CONTAINER (hbuttonbox2), about_close_btn);
	GTK_WIDGET_SET_FLAGS (about_close_btn, GTK_CAN_DEFAULT);

	gtk_signal_connect_after (GTK_OBJECT (aboutDlg), "map",
				  GTK_SIGNAL_FUNC (on_aboutDlg_map),
				  NULL);
	gtk_signal_connect_after (GTK_OBJECT (about_close_btn), "clicked",
				  GTK_SIGNAL_FUNC (on_about_close_btn_clicked),
				  NULL);

	gtk_window_add_accel_group (GTK_WINDOW (aboutDlg), accel_group);

	return aboutDlg;
}
