/*
	XMMS Song Info plugin
	Copyright (c) 2004 Nikola Kotur

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA  02111-1307, USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>
#include <glib.h>
#include <xmms/plugin.h>
#include <xmms/util.h>
#include <xmms/xmmsctrl.h>
#include <gtk/gtk.h>

#include "songinfo.h"
#include "../config.h"
#include "mp3info.h"
#include "interface.h"


/*
  The data structure that holds the information about this plugin...
 */
GeneralPlugin songinfo_gp =
{
	NULL,             /* Handle (Filled by XMMS)   */
	NULL,             /* Filename (Filled by XMMS) */
	0,                /* Session ID                */
	"SongInfo plugin",/* Description               */
	init_plugin,      /* Init function             */
	show_about_xmms,  /* About box                 */
	show_config,      /* Configure                 */
	finalize_plugin   /* Cleanup                   */
};


/* XMMS prvo za ovo pita */
GeneralPlugin *get_gplugin_info(void)
{
	return &songinfo_gp;
}

/* Is string printable or not? */
int is_printable(char *str)
{
	int i;
	for (i = 0; i < strlen(str); i++)
		if (!isprint(str[i]))
			return 0;
	return 1;
}


gint gtk_timer(void)
{
	int p_pos, i;
	char *p_file;
	static char p_file_old[256];
	ext_id3_record id3;

	/* Pita XMMS za mesto u playlisti i ime fajla */
	p_pos = xmms_remote_get_playlist_pos(SESSIONID);
	p_file = xmms_remote_get_playlist_file(SESSIONID, p_pos);
	if (strcmp(p_file_old, p_file))
	{
		strcpy(p_file_old, p_file);
		/* Ovde uzima id3 tag: */
		getmp3info(p_file, &id3);
		if (id3.is_valid)
		{
			if (is_printable(id3.artist))
				gtk_label_set_text(GTK_LABEL (lArtist), id3.artist);
			else
				gtk_label_set_text(GTK_LABEL (lArtist), "n/a");
			if (is_printable(id3.title))
				gtk_label_set_text(GTK_LABEL (lTitle), id3.title);
			else
				gtk_label_set_text(GTK_LABEL (lTitle), "n/a");
			if (is_printable(id3.album))
				gtk_label_set_text(GTK_LABEL (lAlbum), id3.album);
			else
				gtk_label_set_text(GTK_LABEL (lAlbum), "n/a");
			if (is_printable(id3.year))
				gtk_label_set_text(GTK_LABEL (lYear), id3.year);
			else
				gtk_label_set_text(GTK_LABEL (lYear), "n/a");
			if (GTK_TOGGLE_BUTTON (check_button)->active)
			{
				gtk_label_set_text(GTK_LABEL (lmComment), "Comment:");
				if (is_printable(id3.comment))
					gtk_label_set_text(GTK_LABEL (lComment), id3.comment);
				else
					gtk_label_set_text(GTK_LABEL (lComment), "n/a");
			}
			else
			{
				gtk_label_set_text(GTK_LABEL (lComment), "");
				gtk_label_set_text(GTK_LABEL (lmComment), "");
			}
		}
		else
		{
				gtk_label_set_text(GTK_LABEL (lArtist), "n/a");
				gtk_label_set_text(GTK_LABEL (lTitle), "n/a");
				gtk_label_set_text(GTK_LABEL (lAlbum), "n/a");
				gtk_label_set_text(GTK_LABEL (lYear), "n/a");
				gtk_label_set_text(GTK_LABEL (lComment), "n/a");
		}
	}

	return TRUE;
}


void init_plugin(void)
{
	shown = 0;
	show_config();
	tag = gtk_timeout_add( 500, (GtkFunction) gtk_timer, NULL);
	gtk_toggle_button_set_active( GTK_CHECK_BUTTON (check_button), TRUE );

}


void show_config()
{
	if (!shown)
	{
		dlg = create_wSongInfo();
		gtk_widget_show(dlg);
		shown = 1;
	}
}


void finalize_plugin(void)
{
	gtk_timeout_remove(tag);
	gtk_widget_destroy(lookup_widget(GTK_WIDGET(dlg), "wSongInfo"));
	//g_return_if_fail (dlg != NULL);
	/*
	FIXME: Kako da ga ubijem?
	*/
}

